Loading...
Searching...
No Matches
ON_Viewport Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_viewport.h>`

Inheritance diagram for ON_Viewport:

## Public Member Functions

| ON_Viewport ()
| ~ON_Viewport ()
ON_Viewport & | operator= (const ON_Viewport &)
bool | IsValidCamera () const
bool | IsValidFrustum () const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
void | Initialize ()
ON::view_projection | Projection () const
bool | SetProjection (ON::view_projection projection)
bool | ChangeToParallelProjection (bool bSymmetricFrustum)
bool | ChangeToPerspectiveProjection (double target_distance, bool bSymmetricFrustum, double lens_length)
bool | ChangeToTwoPointPerspectiveProjection (double target_distance, ON_3dVector up, double lens_length)
bool | IsPerspectiveProjection () const
bool | IsTwoPointPerspectiveProjection () const
bool | IsParallelProjection () const
bool | SetCameraLocation (const ON_3dPoint &)
bool | SetCameraDirection (const ON_3dVector &)
bool | SetCameraUp (const ON_3dVector &)
ON_3dPoint | CameraLocation () const
ON_3dVector | CameraDirection () const
ON_3dVector | CameraUp () const
bool | CameraLocationIsLocked () const
bool | CameraDirectionIsLocked () const
bool | CameraUpIsLocked () const
bool | FrustumIsLeftRightSymmetric () const
bool | FrustumIsTopBottomSymmetric () const
void | SetCameraLocationLock (bool bLockCameraLocation)
void | SetCameraDirectionLock (bool bLockCameraDirection)
void | SetCameraUpLock (bool bLockCameraUp)
void | SetFrustumLeftRightSymmetry (bool bForceLeftRightSymmetry)
void | SetFrustumTopBottomSymmetry (bool bForceTopBottomSymmetry)
void | UnlockCamera ()
void | UnlockFrustumSymmetry ()
bool | GetCameraFrame (double *, double *, double *, double *) const
ON_3dVector | CameraX () const
ON_3dVector | CameraY () const
ON_3dVector | CameraZ () const
bool | IsCameraFrameWorldPlan (int *, int *, int *)
bool | GetCameraExtents (int, int, const double *, ON_BoundingBox &cambbox, int bGrowBox=false) const
bool | GetCameraExtents (const ON_BoundingBox &, ON_BoundingBox &cambbox, int bGrowBox=false) const
bool | GetCameraExtents (ON_3dPoint &, double, ON_BoundingBox &cambox, int bGrowBox=false) const
bool | SetFrustum (double left, double right, double bottom, double top, double near_dist, double far_dist)
bool | GetFrustum (double *left, double *right, double *bottom, double *top, double *near_dist=NULL, double *far_dist=NULL) const
bool | SetFrustumAspect (double)
bool | GetFrustumAspect (double &) const
bool | GetFrustumCenter (double *) const
double | FrustumLeft () const
double | FrustumRight () const
double | FrustumBottom () const
double | FrustumTop () const
double | FrustumNear () const
double | FrustumFar () const
double | FrustumWidth () const
double | FrustumHeight () const
double | FrustumMinimumDiameter () const
double | FrustumMaximumDiameter () const
bool | SetFrustumNearFar (const double *bboxmin, const double *bboxmax)
bool | SetFrustumNearFar (const double *center, double radius)
bool | SetFrustumNearFar (double near_dist, double far_dist)
bool | ChangeToSymmetricFrustum (bool bLeftRightSymmetric, bool bTopBottomSymmetric, double target_distance)
bool | GetPointDepth (ON_3dPoint point, double *near_dist, double *far_dist, bool bGrowNearFar=false) const
bool | GetPointDepth (ON_3dPoint point, double *view_plane_depth) const
bool | GetBoundingBoxDepth (ON_BoundingBox bbox, double *near_dist, double *far_dist, bool bGrowNearFar=false) const
bool | GetSphereDepth (ON_Sphere sphere, double *near_dist, double *far_dist, bool bGrowNearFar=false) const
bool | SetFrustumNearFar (double near_dist, double far_dist, double min_near_dist, double min_near_over_far, double target_dist)
bool | SetFrustumNearFar (double near_dist, double far_dist, double min_near_dist, double min_near_over_far, double target_dist, double relative_depth_bias)
bool | GetNearPlane (ON_Plane &near_plane) const
bool | GetNearPlaneEquation (ON_PlaneEquation &near_plane_equation) const
bool | GetFarPlane (ON_Plane &far_plane) const
bool | GetFarPlaneEquation (ON_PlaneEquation &far_plane_equation) const
bool | GetViewPlane (double view_plane_depth, ON_Plane &view_plane) const
bool | GetViewPlaneEquation (double view_plane_depth, ON_PlaneEquation &view_plane_equation) const
bool | GetFrustumLeftPlane (ON_Plane &left_plane) const
bool | GetFrustumLeftPlaneEquation (ON_PlaneEquation &left_plane_equation) const
bool | GetFrustumRightPlane (ON_Plane &right_plane) const
bool | GetFrustumRightPlaneEquation (ON_PlaneEquation &right_plane_equation) const
bool | GetFrustumBottomPlane (ON_Plane &bottom_plane) const
bool | GetFrustumBottomPlaneEquation (ON_PlaneEquation &bottom_plane_equation) const
bool | GetFrustumTopPlane (ON_Plane &top_plane) const
bool | GetFrustumTopPlaneEquation (ON_PlaneEquation &top_plane_equation) const
bool | GetNearRect (ON_3dPoint &left_bottom, ON_3dPoint &right_bottom, ON_3dPoint &left_top, ON_3dPoint &right_top) const
bool | GetFarRect (ON_3dPoint &left_bottom, ON_3dPoint &right_bottom, ON_3dPoint &left_top, ON_3dPoint &right_top) const
bool | GetViewPlaneRect (double view_plane_depth, ON_3dPoint &left_bottom, ON_3dPoint &right_bottom, ON_3dPoint &left_top, ON_3dPoint &right_top) const
bool | SetScreenPort (int port_left, int port_right, int port_bottom, int port_top, int port_near=0, int port_far=0)
bool | GetScreenPort (int *left, int *right, int *port_bottom, int *port_top, int *port_near=NULL, int *port_far=NULL) const
int | ScreenPortWidth () const
int | ScreenPortHeight () const
bool | GetScreenPortAspect (double &) const
bool | GetCameraAngle (double *half_diagonal_angle, double *half_vertical_angle, double *half_horizontal_angle) const
bool | GetCameraAngle (double *half_smallest_angle) const
bool | SetCameraAngle (double half_smallest_angle)
bool | GetCamera35mmLensLength (double *lens_length) const
bool | SetCamera35mmLensLength (double lens_length)
bool | GetCamera35mmLenseLength (double *lens_length) const
bool | SetCamera35mmLenseLength (double lens_length)
bool | GetXform (ON::coordinate_system srcCS, ON::coordinate_system destCS, ON_Xform &matrix) const
bool | GetFrustumLine (double screenx, double screeny, ON_Line &world_line) const
bool | GetWorldToScreenScale (const ON_3dPoint &point_in_frustum, double *pixels_per_unit) const
bool | GetCoordinateSprite (int, int, int, int[3], double[3][2]) const
bool | Extents (double half_view_angle, const ON_BoundingBox &world_bbox)
bool | Extents (double half_view_angle, const ON_3dPoint &center, double radius)
bool | ZoomToScreenRect (int screen_x0, int screen_y0, int screen_x1, int screen_y1)
bool | DollyCamera (const ON_3dVector &dolly_vector)
bool | GetDollyCameraVector (int screen_x0, int screen_y0, int screen_x1, int screen_y1, double proj_plane_dist, ON_3dVector &dolly_vector) const
bool | DollyFrustum (double dolly_distance)
bool | SetViewScale (double x, double y)
void | GetViewScale (double *x, double *y) const
ON_Xform | ClipModXform () const
ON_Xform | ClipModInverseXform () const
bool | ClipModXformIsIdentity () const
ON_3dPoint | FrustumCenterPoint (double target_distance) const
ON_3dPoint | TargetPoint () const
bool | SetTargetPoint (ON_3dPoint target_point)
double | TargetDistance (bool bUseFrustumCenterFallback) const
double | ClipCoordDepthBias (double relative_depth_bias, double clip_z, double clip_w) const
bool | GetClipCoordDepthBiasXform (double relative_depth_bias, ON_Xform &clip_bias) const
void | SetPerspectiveClippingPlaneConstraints (unsigned int depth_buffer_bit_depth)
void | SetPerspectiveMinNearOverFar (double min_near_over_far)
double | PerspectiveMinNearOverFar () const
void | SetPerspectiveMinNearDist (double min_near_dist)
double | PerspectiveMinNearDist () const
bool | SetViewportId (const ON_UUID &viewport_id)
ON_UUID | ViewportId (void) const
void | ChangeViewportId (const ON_UUID &viewport_id)
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON::object_type | ObjectType () const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static void | GetPerspectiveClippingPlaneConstraints (ON_3dPoint camera_location, unsigned int depth_buffer_bit_depth, double *min_near_dist, double *min_near_over_far)

## Static Public Attributes

static const ON_3dVector | Default3dCameraDirection
static const double | DefaultNearDist
static const double | DefaultFarDist
static const double | DefaultMinNearDist
static const double | DefaultMinNearOverFar

## Protected Attributes

bool | m_bValidCamera
bool | m_bValidFrustum
bool | m_bValidPort
unsigned char | m_reserved1
ON::view_projection | m_projection
bool | m_bLockCamUp
bool | m_bLockCamDir
bool | m_bLockCamLoc
unsigned char | m_frustum_symmetry_flags
ON_3dPoint | m_CamLoc
ON_3dVector | m_CamDir
ON_3dVector | m_CamUp
ON_3dVector | m_CamX
ON_3dVector | m_CamY
ON_3dVector | m_CamZ
double | m_frus_left
double | m_frus_right
double | m_frus_bottom
double | m_frus_top
double | m_frus_near
double | m_frus_far
int | m_port_left
int | m_port_right
int | m_port_bottom
int | m_port_top
int | m_port_near
int | m_port_far
ON_3dPoint | m_target_point

## Detailed Description

Definition at line 31 of file opennurbs_viewport.h.

## Constructor & Destructor Documentation

## ON_Viewport()

ON_Viewport::ON_Viewport | ( |  | ) |

Referenced by operator=().

## ~ON_Viewport()

ON_Viewport::~ON_Viewport | ( |  | ) |

## Member Function Documentation

## CameraDirection()

ON_3dVector ON_Viewport::CameraDirection | ( |  | ) | const

## CameraDirectionIsLocked()

bool ON_Viewport::CameraDirectionIsLocked | ( |  | ) | const

## CameraLocation()

ON_3dPoint ON_Viewport::CameraLocation | ( |  | ) | const

## CameraLocationIsLocked()

bool ON_Viewport::CameraLocationIsLocked | ( |  | ) | const

## CameraUp()

ON_3dVector ON_Viewport::CameraUp | ( |  | ) | const

## CameraUpIsLocked()

bool ON_Viewport::CameraUpIsLocked | ( |  | ) | const

## CameraX()

ON_3dVector ON_Viewport::CameraX | ( |  | ) | const

## CameraY()

ON_3dVector ON_Viewport::CameraY | ( |  | ) | const

## CameraZ()

ON_3dVector ON_Viewport::CameraZ | ( |  | ) | const

## ChangeToParallelProjection()

bool ON_Viewport::ChangeToParallelProjection | ( | bool | bSymmetricFrustum | ) |

## ChangeToPerspectiveProjection()

bool ON_Viewport::ChangeToPerspectiveProjection | ( | double | target_distance,
|  | bool | bSymmetricFrustum,
|  | double | lens_length )

## ChangeToSymmetricFrustum()

bool ON_Viewport::ChangeToSymmetricFrustum | ( | bool | bLeftRightSymmetric,
|  | bool | bTopBottomSymmetric,
|  | double | target_distance )

## ChangeToTwoPointPerspectiveProjection()

bool ON_Viewport::ChangeToTwoPointPerspectiveProjection | ( | double | target_distance,
|  | ON_3dVector | up,
|  | double | lens_length )

## ChangeViewportId()

void ON_Viewport::ChangeViewportId | ( | const ON_UUID & | viewport_id | ) |

## ClipCoordDepthBias()

double ON_Viewport::ClipCoordDepthBias | ( | double | relative_depth_bias,
|  | double | clip_z,
|  | double | clip_w ) const

## ClipModInverseXform()

ON_Xform ON_Viewport::ClipModInverseXform | ( |  | ) | const

## ClipModXform()

ON_Xform ON_Viewport::ClipModXform | ( |  | ) | const

## ClipModXformIsIdentity()

bool ON_Viewport::ClipModXformIsIdentity | ( |  | ) | const

## Dimension()

int ON_Viewport::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## DollyCamera()

bool ON_Viewport::DollyCamera | ( | const ON_3dVector & | dolly_vector | ) |

## DollyFrustum()

bool ON_Viewport::DollyFrustum | ( | double | dolly_distance | ) |

## Dump()

void ON_Viewport::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Extents() [1/2]

bool ON_Viewport::Extents | ( | double | half_view_angle,
|  | const ON_3dPoint & | center,
|  | double | radius )

## Extents() [2/2]

bool ON_Viewport::Extents | ( | double | half_view_angle,
|  | const ON_BoundingBox & | world_bbox )

## FrustumBottom()

double ON_Viewport::FrustumBottom | ( |  | ) | const

## FrustumCenterPoint()

ON_3dPoint ON_Viewport::FrustumCenterPoint | ( | double | target_distance | ) | const

## FrustumFar()

double ON_Viewport::FrustumFar | ( |  | ) | const

## FrustumHeight()

double ON_Viewport::FrustumHeight | ( |  | ) | const

## FrustumIsLeftRightSymmetric()

bool ON_Viewport::FrustumIsLeftRightSymmetric | ( |  | ) | const

## FrustumIsTopBottomSymmetric()

bool ON_Viewport::FrustumIsTopBottomSymmetric | ( |  | ) | const

## FrustumLeft()

double ON_Viewport::FrustumLeft | ( |  | ) | const

## FrustumMaximumDiameter()

double ON_Viewport::FrustumMaximumDiameter | ( |  | ) | const

## FrustumMinimumDiameter()

double ON_Viewport::FrustumMinimumDiameter | ( |  | ) | const

## FrustumNear()

double ON_Viewport::FrustumNear | ( |  | ) | const

## FrustumRight()

double ON_Viewport::FrustumRight | ( |  | ) | const

## FrustumTop()

double ON_Viewport::FrustumTop | ( |  | ) | const

## FrustumWidth()

double ON_Viewport::FrustumWidth | ( |  | ) | const

## GetBBox()

ON_BOOL32 ON_Viewport::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = false ) const

virtual

Implements ON_Geometry.

## GetBoundingBoxDepth()

bool ON_Viewport::GetBoundingBoxDepth | ( | ON_BoundingBox | bbox,
|  | double * | near_dist,
|  | double * | far_dist,
|  | bool | bGrowNearFar = false ) const

## GetCamera35mmLenseLength()

bool ON_Viewport::GetCamera35mmLenseLength | ( | double * | lens_length | ) | const

## GetCamera35mmLensLength()

bool ON_Viewport::GetCamera35mmLensLength | ( | double * | lens_length | ) | const

## GetCameraAngle() [1/2]

bool ON_Viewport::GetCameraAngle | ( | double * | half_diagonal_angle,
|  | double * | half_vertical_angle,
|  | double * | half_horizontal_angle ) const

## GetCameraAngle() [2/2]

bool ON_Viewport::GetCameraAngle | ( | double * | half_smallest_angle | ) | const

## GetCameraExtents() [1/3]

bool ON_Viewport::GetCameraExtents | ( | const ON_BoundingBox & | ,
|  | ON_BoundingBox & | cambbox,
|  | int | bGrowBox = false ) const

## GetCameraExtents() [2/3]

bool ON_Viewport::GetCameraExtents | ( | int | ,
|  | int | ,
|  | const double * | ,
|  | ON_BoundingBox & | cambbox,
|  | int | bGrowBox = false ) const

## GetCameraExtents() [3/3]

bool ON_Viewport::GetCameraExtents | ( | ON_3dPoint & | ,
|  | double | ,
|  | ON_BoundingBox & | cambox,
|  | int | bGrowBox = false ) const

## GetCameraFrame()

bool ON_Viewport::GetCameraFrame | ( | double * | ,
|  | double * | ,
|  | double * | ,
|  | double * | ) const

## GetClipCoordDepthBiasXform()

bool ON_Viewport::GetClipCoordDepthBiasXform | ( | double | relative_depth_bias,
|  | ON_Xform & | clip_bias ) const

## GetCoordinateSprite()

bool ON_Viewport::GetCoordinateSprite | ( | int | ,
|  | int | ,
|  | int | ,
|  | int | [3],
|  | double | [3][2] ) const

## GetDollyCameraVector()

bool ON_Viewport::GetDollyCameraVector | ( | int | screen_x0,
|  | int | screen_y0,
|  | int | screen_x1,
|  | int | screen_y1,
|  | double | proj_plane_dist,
|  | ON_3dVector & | dolly_vector ) const

## GetFarPlane()

bool ON_Viewport::GetFarPlane | ( | ON_Plane & | far_plane | ) | const

## GetFarPlaneEquation()

bool ON_Viewport::GetFarPlaneEquation | ( | ON_PlaneEquation & | far_plane_equation | ) | const

## GetFarRect()

bool ON_Viewport::GetFarRect | ( | ON_3dPoint & | left_bottom,
|  | ON_3dPoint & | right_bottom,
|  | ON_3dPoint & | left_top,
|  | ON_3dPoint & | right_top ) const

## GetFrustum()

bool ON_Viewport::GetFrustum | ( | double * | left,
|  | double * | right,
|  | double * | bottom,
|  | double * | top,
|  | double * | near_dist = NULL,
|  | double * | far_dist = NULL ) const

## GetFrustumAspect()

bool ON_Viewport::GetFrustumAspect | ( | double & |  | ) | const

## GetFrustumBottomPlane()

bool ON_Viewport::GetFrustumBottomPlane | ( | ON_Plane & | bottom_plane | ) | const

## GetFrustumBottomPlaneEquation()

bool ON_Viewport::GetFrustumBottomPlaneEquation | ( | ON_PlaneEquation & | bottom_plane_equation | ) | const

## GetFrustumCenter()

bool ON_Viewport::GetFrustumCenter | ( | double * |  | ) | const

## GetFrustumLeftPlane()

bool ON_Viewport::GetFrustumLeftPlane | ( | ON_Plane & | left_plane | ) | const

## GetFrustumLeftPlaneEquation()

bool ON_Viewport::GetFrustumLeftPlaneEquation | ( | ON_PlaneEquation & | left_plane_equation | ) | const

## GetFrustumLine()

bool ON_Viewport::GetFrustumLine | ( | double | screenx,
|  | double | screeny,
|  | ON_Line & | world_line ) const

## GetFrustumRightPlane()

bool ON_Viewport::GetFrustumRightPlane | ( | ON_Plane & | right_plane | ) | const

## GetFrustumRightPlaneEquation()

bool ON_Viewport::GetFrustumRightPlaneEquation | ( | ON_PlaneEquation & | right_plane_equation | ) | const

## GetFrustumTopPlane()

bool ON_Viewport::GetFrustumTopPlane | ( | ON_Plane & | top_plane | ) | const

## GetFrustumTopPlaneEquation()

bool ON_Viewport::GetFrustumTopPlaneEquation | ( | ON_PlaneEquation & | top_plane_equation | ) | const

## GetNearPlane()

bool ON_Viewport::GetNearPlane | ( | ON_Plane & | near_plane | ) | const

## GetNearPlaneEquation()

bool ON_Viewport::GetNearPlaneEquation | ( | ON_PlaneEquation & | near_plane_equation | ) | const

## GetNearRect()

bool ON_Viewport::GetNearRect | ( | ON_3dPoint & | left_bottom,
|  | ON_3dPoint & | right_bottom,
|  | ON_3dPoint & | left_top,
|  | ON_3dPoint & | right_top ) const

## GetPerspectiveClippingPlaneConstraints()

void ON_Viewport::GetPerspectiveClippingPlaneConstraints | ( | ON_3dPoint | camera_location,
|  | unsigned int | depth_buffer_bit_depth,
|  | double * | min_near_dist,
|  | double * | min_near_over_far )

static

## GetPointDepth() [1/2]

bool ON_Viewport::GetPointDepth | ( | ON_3dPoint | point,
|  | double * | near_dist,
|  | double * | far_dist,
|  | bool | bGrowNearFar = false ) const

## GetPointDepth() [2/2]

bool ON_Viewport::GetPointDepth | ( | ON_3dPoint | point,
|  | double * | view_plane_depth ) const

## GetScreenPort()

bool ON_Viewport::GetScreenPort | ( | int * | left,
|  | int * | right,
|  | int * | port_bottom,
|  | int * | port_top,
|  | int * | port_near = NULL,
|  | int * | port_far = NULL ) const

## GetScreenPortAspect()

bool ON_Viewport::GetScreenPortAspect | ( | double & |  | ) | const

## GetSphereDepth()

bool ON_Viewport::GetSphereDepth | ( | ON_Sphere | sphere,
|  | double * | near_dist,
|  | double * | far_dist,
|  | bool | bGrowNearFar = false ) const

## GetViewPlane()

bool ON_Viewport::GetViewPlane | ( | double | view_plane_depth,
|  | ON_Plane & | view_plane ) const

## GetViewPlaneEquation()

bool ON_Viewport::GetViewPlaneEquation | ( | double | view_plane_depth,
|  | ON_PlaneEquation & | view_plane_equation ) const

## GetViewPlaneRect()

bool ON_Viewport::GetViewPlaneRect | ( | double | view_plane_depth,
|  | ON_3dPoint & | left_bottom,
|  | ON_3dPoint & | right_bottom,
|  | ON_3dPoint & | left_top,
|  | ON_3dPoint & | right_top ) const

## GetViewScale()

void ON_Viewport::GetViewScale | ( | double * | x,
|  | double * | y ) const

## GetWorldToScreenScale()

bool ON_Viewport::GetWorldToScreenScale | ( | const ON_3dPoint & | point_in_frustum,
|  | double * | pixels_per_unit ) const

## GetXform()

bool ON_Viewport::GetXform | ( | ON::coordinate_system | srcCS,
|  | ON::coordinate_system | destCS,
|  | ON_Xform & | matrix ) const

## Initialize()

void ON_Viewport::Initialize | ( |  | ) |

## IsCameraFrameWorldPlan()

bool ON_Viewport::IsCameraFrameWorldPlan | ( | int * | ,
|  | int * | ,
|  | int * | )

## IsParallelProjection()

bool ON_Viewport::IsParallelProjection | ( |  | ) | const

## IsPerspectiveProjection()

bool ON_Viewport::IsPerspectiveProjection | ( |  | ) | const

## IsTwoPointPerspectiveProjection()

bool ON_Viewport::IsTwoPointPerspectiveProjection | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Viewport::IsValid | ( | ON_TextLog * | text_log = NULL | ) | const

virtual

Implements ON_Object.

## IsValidCamera()

bool ON_Viewport::IsValidCamera | ( |  | ) | const

## IsValidFrustum()

bool ON_Viewport::IsValidFrustum | ( |  | ) | const

## operator=()

ON_Viewport & ON_Viewport::operator= | ( | const ON_Viewport & |  | ) |

References ON_Viewport().

## PerspectiveMinNearDist()

double ON_Viewport::PerspectiveMinNearDist | ( |  | ) | const

## PerspectiveMinNearOverFar()

double ON_Viewport::PerspectiveMinNearOverFar | ( |  | ) | const

## Projection()

ON::view_projection ON_Viewport::Projection | ( |  | ) | const

## Read()

ON_BOOL32 ON_Viewport::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## ScreenPortHeight()

int ON_Viewport::ScreenPortHeight | ( |  | ) | const

## ScreenPortWidth()

int ON_Viewport::ScreenPortWidth | ( |  | ) | const

## SetCamera35mmLenseLength()

bool ON_Viewport::SetCamera35mmLenseLength | ( | double | lens_length | ) |

## SetCamera35mmLensLength()

bool ON_Viewport::SetCamera35mmLensLength | ( | double | lens_length | ) |

## SetCameraAngle()

bool ON_Viewport::SetCameraAngle | ( | double | half_smallest_angle | ) |

## SetCameraDirection()

bool ON_Viewport::SetCameraDirection | ( | const ON_3dVector & |  | ) |

## SetCameraDirectionLock()

void ON_Viewport::SetCameraDirectionLock | ( | bool | bLockCameraDirection | ) |

## SetCameraLocation()

bool ON_Viewport::SetCameraLocation | ( | const ON_3dPoint & |  | ) |

## SetCameraLocationLock()

void ON_Viewport::SetCameraLocationLock | ( | bool | bLockCameraLocation | ) |

## SetCameraUp()

bool ON_Viewport::SetCameraUp | ( | const ON_3dVector & |  | ) |

## SetCameraUpLock()

void ON_Viewport::SetCameraUpLock | ( | bool | bLockCameraUp | ) |

## SetFrustum()

bool ON_Viewport::SetFrustum | ( | double | left,
|  | double | right,
|  | double | bottom,
|  | double | top,
|  | double | near_dist,
|  | double | far_dist )

## SetFrustumAspect()

bool ON_Viewport::SetFrustumAspect | ( | double |  | ) |

## SetFrustumLeftRightSymmetry()

void ON_Viewport::SetFrustumLeftRightSymmetry | ( | bool | bForceLeftRightSymmetry | ) |

## SetFrustumNearFar() [1/5]

bool ON_Viewport::SetFrustumNearFar | ( | const double * | bboxmin,
|  | const double * | bboxmax )

## SetFrustumNearFar() [2/5]

bool ON_Viewport::SetFrustumNearFar | ( | const double * | center,
|  | double | radius )

## SetFrustumNearFar() [3/5]

bool ON_Viewport::SetFrustumNearFar | ( | double | near_dist,
|  | double | far_dist )

## SetFrustumNearFar() [4/5]

bool ON_Viewport::SetFrustumNearFar | ( | double | near_dist,
|  | double | far_dist,
|  | double | min_near_dist,
|  | double | min_near_over_far,
|  | double | target_dist )

## SetFrustumNearFar() [5/5]

bool ON_Viewport::SetFrustumNearFar | ( | double | near_dist,
|  | double | far_dist,
|  | double | min_near_dist,
|  | double | min_near_over_far,
|  | double | target_dist,
|  | double | relative_depth_bias )

## SetFrustumTopBottomSymmetry()

void ON_Viewport::SetFrustumTopBottomSymmetry | ( | bool | bForceTopBottomSymmetry | ) |

## SetPerspectiveClippingPlaneConstraints()

void ON_Viewport::SetPerspectiveClippingPlaneConstraints | ( | unsigned int | depth_buffer_bit_depth | ) |

## SetPerspectiveMinNearDist()

void ON_Viewport::SetPerspectiveMinNearDist | ( | double | min_near_dist | ) |

## SetPerspectiveMinNearOverFar()

void ON_Viewport::SetPerspectiveMinNearOverFar | ( | double | min_near_over_far | ) |

## SetProjection()

bool ON_Viewport::SetProjection | ( | ON::view_projection | projection | ) |

## SetScreenPort()

bool ON_Viewport::SetScreenPort | ( | int | port_left,
|  | int | port_right,
|  | int | port_bottom,
|  | int | port_top,
|  | int | port_near = 0,
|  | int | port_far = 0 )

## SetTargetPoint()

bool ON_Viewport::SetTargetPoint | ( | ON_3dPoint | target_point | ) |

## SetViewportId()

bool ON_Viewport::SetViewportId | ( | const ON_UUID & | viewport_id | ) |

## SetViewScale()

bool ON_Viewport::SetViewScale | ( | double | x,
|  | double | y )

## TargetDistance()

double ON_Viewport::TargetDistance | ( | bool | bUseFrustumCenterFallback | ) | const

## TargetPoint()

ON_3dPoint ON_Viewport::TargetPoint | ( |  | ) | const

## Transform()

ON_BOOL32 ON_Viewport::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## UnlockCamera()

void ON_Viewport::UnlockCamera | ( |  | ) |

## UnlockFrustumSymmetry()

void ON_Viewport::UnlockFrustumSymmetry | ( |  | ) |

## ViewportId()

ON_UUID ON_Viewport::ViewportId | ( | void |  | ) | const

## Write()

ON_BOOL32 ON_Viewport::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## ZoomToScreenRect()

bool ON_Viewport::ZoomToScreenRect | ( | int | screen_x0,
|  | int | screen_y0,
|  | int | screen_x1,
|  | int | screen_y1 )

## Member Data Documentation

## Default3dCameraDirection

const ON_3dVector ON_Viewport::Default3dCameraDirection

static

Definition at line 37 of file opennurbs_viewport.h.

## DefaultFarDist

const double ON_Viewport::DefaultFarDist

static

Definition at line 1458 of file opennurbs_viewport.h.

## DefaultMinNearDist

const double ON_Viewport::DefaultMinNearDist

static

Definition at line 1459 of file opennurbs_viewport.h.

## DefaultMinNearOverFar

const double ON_Viewport::DefaultMinNearOverFar

static

Definition at line 1460 of file opennurbs_viewport.h.

## DefaultNearDist

const double ON_Viewport::DefaultNearDist

static

Definition at line 1457 of file opennurbs_viewport.h.

## m_bLockCamDir

bool ON_Viewport::m_bLockCamDir

protected

Definition at line 1379 of file opennurbs_viewport.h.

## m_bLockCamLoc

bool ON_Viewport::m_bLockCamLoc

protected

Definition at line 1380 of file opennurbs_viewport.h.

## m_bLockCamUp

bool ON_Viewport::m_bLockCamUp

protected

Definition at line 1378 of file opennurbs_viewport.h.

## m_bValidCamera

bool ON_Viewport::m_bValidCamera

protected

Definition at line 1356 of file opennurbs_viewport.h.

## m_bValidFrustum

bool ON_Viewport::m_bValidFrustum

protected

Definition at line 1357 of file opennurbs_viewport.h.

## m_bValidPort

bool ON_Viewport::m_bValidPort

protected

Definition at line 1358 of file opennurbs_viewport.h.

## m_CamDir

ON_3dVector ON_Viewport::m_CamDir

protected

Definition at line 1384 of file opennurbs_viewport.h.

## m_CamLoc

ON_3dPoint ON_Viewport::m_CamLoc

protected

Definition at line 1383 of file opennurbs_viewport.h.

## m_CamUp

ON_3dVector ON_Viewport::m_CamUp

protected

Definition at line 1385 of file opennurbs_viewport.h.

## m_CamX

ON_3dVector ON_Viewport::m_CamX

protected

Definition at line 1388 of file opennurbs_viewport.h.

## m_CamY

ON_3dVector ON_Viewport::m_CamY

protected

Definition at line 1389 of file opennurbs_viewport.h.

## m_CamZ

ON_3dVector ON_Viewport::m_CamZ

protected

Definition at line 1390 of file opennurbs_viewport.h.

## m_frus_bottom

double ON_Viewport::m_frus_bottom

protected

Definition at line 1398 of file opennurbs_viewport.h.

## m_frus_far

double ON_Viewport::m_frus_far

protected

Definition at line 1399 of file opennurbs_viewport.h.

## m_frus_left

double ON_Viewport::m_frus_left

protected

Definition at line 1397 of file opennurbs_viewport.h.

## m_frus_near

double ON_Viewport::m_frus_near

protected

Definition at line 1399 of file opennurbs_viewport.h.

## m_frus_right

double ON_Viewport::m_frus_right

protected

Definition at line 1397 of file opennurbs_viewport.h.

## m_frus_top

double ON_Viewport::m_frus_top

protected

Definition at line 1398 of file opennurbs_viewport.h.

## m_frustum_symmetry_flags

unsigned char ON_Viewport::m_frustum_symmetry_flags

protected

Definition at line 1381 of file opennurbs_viewport.h.

## m_port_bottom

int ON_Viewport::m_port_bottom

protected

Definition at line 1409 of file opennurbs_viewport.h.

## m_port_far

int ON_Viewport::m_port_far

protected

Definition at line 1415 of file opennurbs_viewport.h.

## m_port_left

int ON_Viewport::m_port_left

protected

Definition at line 1408 of file opennurbs_viewport.h.

## m_port_near

int ON_Viewport::m_port_near

protected

Definition at line 1415 of file opennurbs_viewport.h.

## m_port_right

int ON_Viewport::m_port_right

protected

Definition at line 1408 of file opennurbs_viewport.h.

## m_port_top

int ON_Viewport::m_port_top

protected

Definition at line 1409 of file opennurbs_viewport.h.

## m_projection

ON::view_projection ON_Viewport::m_projection

protected

Definition at line 1364 of file opennurbs_viewport.h.

## m_reserved1

unsigned char ON_Viewport::m_reserved1

protected

Definition at line 1359 of file opennurbs_viewport.h.

## m_target_point

ON_3dPoint ON_Viewport::m_target_point

protected

Definition at line 1425 of file opennurbs_viewport.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_viewport.h